;skeleton.asm
.686
.model flat, stdcall
option casemap :none

include \masm32\include\windows.inc

IRP s,<user32,kernel32,gdi32>    ;add others as needed
    IFB <s>
        EXITM
    ENDIF
    include \masm32\include\s.inc
    includelib \masm32\lib\s.lib
ENDM

ID_ICON = 500
ID_EXIT = 600
ID_ABOUT = 700

.data
mbps label dword ;a MESSAGEBOXPARAMS structure
    dd 28        ;structure size (can be as much as 40)
  hWndMain dd ?         ;owner (zero is allowed)
  hInst3 dd ?           ;hInstance containing the icon resource
    dd msgtxt           ;msgbox text
    dd Skeleton$        ;msgbox title
    dd MB_USERICON      ;style flags
    dd ID_ICON          ;icon resource id

MainWindow label dword  ;in reverse order, gets pushed for CreateWindowEx
    dd 0      ;window creation data (only for MDI)
  hInst2 dd ?
    dd 0      ;hMenu
    dd 0      ;hWnd of parent
  MainWindowHeight dd 200
  MainWindowWidth dd 350
  MainWindowY dd 100
  MainWindowX dd 100
    dd WS_OVERLAPPEDWINDOW
    dd offset Skeleton$
    dd wcSK$
    dd 0

MainWC label dword
    dd sizeof WNDCLASSEX
    dd CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW ;rather arbitrary
    dd offset WndProc
    dd 0,0         ;extra sizes wanted
  hInst1 dd ?
  hIcon dd ?
  cursor dd 0
  brush dd 0
    dd 0           ;lpszMenuName
    dd wcSK$         ;lpszClassname
    dd 0   ;hIconSm, 0 okay if the icon resource contains a small version

mymenu dd 0       ;This structure MUST be word aligned in the file.
    dw 0,ID_EXIT,"E","&","x","i","t",0
    dw 80h,ID_ABOUT,"&","A","b","o","u","t",0

wcSK$ db "wcSK",0
Skeleton$ db "Skeleton",0
msgtxt db "Bare bones Win32 ASM application",0

.code
start:
    invoke GetModuleHandleA,0
    mov  hInst1,eax
    mov  hInst2,eax
    mov  hInst3,eax
    invoke LoadIcon,eax,ID_ICON
    mov  hIcon,eax
    invoke GetStockObject,LTGRAY_BRUSH
    mov  brush,eax
    invoke LoadCursorA,0,IDC_ARROW
    mov  cursor,eax
    invoke RegisterClassExA,addr MainWC
    test eax,eax
    jz   Quit_with_eax
    invoke GetSystemMetrics,0   ;get screen width in pixels
    test eax,eax
    jz   GotWindowSite   ;centre the window if coords are available
    sub  eax,MainWindowWidth
    shr  eax,1
    mov  MainWindowX,eax
    invoke GetSystemMetrics,1   ;get screen height in pixels
    sub  eax,MainWindowHeight
    shr  eax,1
    mov  MainWindowY,eax
GotWindowSite:
    mov  esi,offset MainWindow
    mov  ecx,(sizeof WNDCLASSEX)/4
@@: lodsd    ;push a data structure for CreateWindowEx
    push eax
    loop @B
    call CreateWindowEx
    test eax,eax
    jz   short Quit_with_eax
    mov  hWndMain,eax  ;in practice this handle would be stored
    xchg eax,esi       ; in several different structures
    invoke LoadMenuIndirect,addr mymenu
    invoke SetMenu,esi,eax
    invoke ShowWindow,esi,SW_NORMAL
    invoke UpdateWindow,esi
    sub  esp,7*4    ;make a buffer for a message structure of seven dwords
    mov  ebp,esp
MsgLoop:
    invoke GetMessageA,ebp,0,0,0
    test eax,eax
    jz   Quit
    invoke TranslateMessage,ebp
    invoke DispatchMessageA,ebp
    jmp  MsgLoop
Quit:
    mov eax,[ebp+10h]  ;wParam
Quit_with_eax:
    invoke ExitProcess,eax

tblMain label dword
    dw WM_DESTROY
    dd HandleWM_DESTROY
    dw WM_COMMAND
    dd HandleWM_COMMAND
    dw -1
    dd JmpDefWndProc
tblCmd label dword
    dw ID_EXIT
    dd CmdExit
    dw ID_ABOUT
    dd CmdAbout
    dw -1
    dd Done0

hWnd equ dword ptr[ebp+8]
uMsg equ word ptr[ebp+12]
wParam equ word ptr[ebp+16]
lParam equ dword ptr[ebp+20]
JmpDefWndProc:
    leave
    jmp  DefWindowProc
WndProc:
    push ebp
    mov  ebp,esp
    mov  ax,uMsg
    mov  ecx,offset tblMain
    jmp  Branch24

HandleWM_DESTROY:
    invoke PostQuitMessage,0
    jmp  short Done0

HandleWM_COMMAND:
    mov  ax,wParam   ;the command ID
    mov  ecx,offset tblCmd
    jmp  Branch24

CmdExit:
    invoke SendMessageA,hWnd,WM_SYSCOMMAND,SC_CLOSE,0
  Done0: xor eax,eax
  Done:  leave
    ret 10h

CmdAbout:
    invoke MessageBoxIndirectA,addr mbps
    jmp Done0

ThisOne: jmp dword ptr[ecx+2]
Branch24:            ;ecx = word-dword table, ax = what to look up
    cmp  word ptr [ecx],-1
    je   ThisOne
    cmp  ax,[ecx]
    je   ThisOne
    add  ecx,6
    jmp  Branch24

end start
